diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/rta-tig-mobile-gaming.h ns-3.47/src/applications/model/rta-tig-mobile-gaming.h
--- ns-3.46/src/applications/model/rta-tig-mobile-gaming.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/src/applications/model/rta-tig-mobile-gaming.h	2026-02-16 16:08:49.570229800 -0800
@@ -0,0 +1,130 @@
+/*
+ * Copyright (c) 2024 DERONNE SOFTWARE ENGINEERING
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
+ */
+
+#ifndef RTA_TIG_MOBILE_GAMING_H
+#define RTA_TIG_MOBILE_GAMING_H
+
+#include "source-application.h"
+
+#include "ns3/address.h"
+#include "ns3/event-id.h"
+#include "ns3/ptr.h"
+
+namespace ns3
+{
+
+class UniformRandomVariable;
+class LargestExtremeValueRandomVariable;
+
+/**
+ * @ingroup applications
+ * @brief Generate RT mobile gaming traffic.
+ *
+ * This RT mobile gaming traffic generator follows requirements from IEEE 802.11 Real Time
+ * Applications TIG Report (Section 4.1.4: Traffic model) (see applications documentation for
+ * full citation).
+ *
+ * RT mobile gaming traffic typically consists in small packets (between 30 and 500 Bytes) for both
+ * uplink and downlink, where usually downlink packets are bigger than uplink ones. Packets are
+ * generated on average every 30-60ms for uplink and downlink, usually downlink packet interval is
+ * larger than uplink one. The bandwidth for RT mobile gaming traffic is between 100kbps and 1Mbps.
+ */
+class RtaTigMobileGaming : public SourceApplication
+{
+  public:
+    /**
+     * @brief Get the type ID.
+     * @return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    RtaTigMobileGaming();
+    ~RtaTigMobileGaming() override;
+
+    /// Model presets enumeration
+    enum class ModelPresets : uint8_t
+    {
+        CUSTOM = 0, //< Custom traffic model (by default, load parameters of DL status-sync model
+                    // presets)
+        STATUS_SYNC_DL, //< DL status-sync model presets
+        STATUS_SYNC_UL, //< UL status-sync model presets
+        LOCKSTEP_DL,    //< DL lockstep model presets
+        LOCKSTEP_UL     //< UL lockstep model presets
+    };
+
+    int64_t AssignStreams(int64_t stream) override;
+
+    /**
+     * Traffic model stages
+     */
+    enum class TrafficModelStage : uint8_t
+    {
+        INITIAL = 0,
+        GAMING = 1,
+        ENDING = 2
+    };
+
+  protected:
+    void DoInitialize() override;
+
+  private:
+    void DoStartApplication() override;
+    void DoStopApplication() override;
+    void DoConnectionSucceeded(Ptr<Socket> socket) override;
+    void CancelEvents() override;
+
+    /**
+     * Schedule the next packet transmission
+     */
+    void ScheduleNext();
+
+    /**
+     * Transmit one initial, gaming or ending packet
+     */
+    void SendPacket();
+
+    ModelPresets m_modelPresets; //!< Model presets to use to configure the traffic generator
+
+    Ptr<UniformRandomVariable>
+        m_initialSizeUniform; //!< Uniform random variable to generate the initial packet size
+    Ptr<UniformRandomVariable>
+        m_endSizeUniform; //!< Uniform random variable to generate the end packet size
+
+    Ptr<LargestExtremeValueRandomVariable>
+        m_levArrivals; //!< Largest extreme value random variable to generate packet arrival times
+    Ptr<LargestExtremeValueRandomVariable>
+        m_levSizes; //!< Largest extreme value random variable to generate packet sizes
+
+    TrafficModelStage m_currentStage{TrafficModelStage::INITIAL}; //!< Hold the current stage
+
+    EventId m_txEvent; //!< Event ID of pending TX event scheduling
+
+    /**
+     * TracedCallback signature for packet and stage.
+     *
+     * @param [in] packet The packet.
+     * @param [in] stage The gaming traffic model stage corresponding to the packet.
+     */
+    typedef void (*TxTracedCallback)(Ptr<const Packet> packet, TrafficModelStage stage);
+
+    /// Traced Callback: transmitted packets and their stage.
+    TracedCallback<Ptr<const Packet>, TrafficModelStage> m_txStageTrace;
+};
+
+/**
+ * Serialize gaming traffic model stage to ostream in a human-readable form.
+ *
+ * @param os std::ostream
+ * @param stage the gaming traffic model stage
+ * @return std::ostream
+ */
+std::ostream& operator<<(std::ostream& os, RtaTigMobileGaming::TrafficModelStage stage);
+
+} // namespace ns3
+
+#endif /* RTA_TIG_MOBILE_GAMING_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/seq-ts-echo-header.cc ns-3.47/src/applications/model/seq-ts-echo-header.cc
--- ns-3.46/src/applications/model/seq-ts-echo-header.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/seq-ts-echo-header.cc	2026-02-16 16:08:49.570229800 -0800
@@ -22,9 +22,7 @@
 NS_OBJECT_ENSURE_REGISTERED(SeqTsEchoHeader);
 
 SeqTsEchoHeader::SeqTsEchoHeader()
-    : m_seq(0),
-      m_tsValue(Simulator::Now()),
-      m_tsEchoReply()
+    : m_tsValue(Simulator::Now())
 {
     NS_LOG_FUNCTION(this);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/seq-ts-echo-header.h ns-3.47/src/applications/model/seq-ts-echo-header.h
--- ns-3.46/src/applications/model/seq-ts-echo-header.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/seq-ts-echo-header.h	2026-02-16 16:08:49.571229700 -0800
@@ -78,7 +78,7 @@
     uint32_t Deserialize(Buffer::Iterator start) override;
 
   private:
-    uint32_t m_seq;     //!< Sequence number
+    uint32_t m_seq{0};  //!< Sequence number
     Time m_tsValue;     //!< Sender's timestamp
     Time m_tsEchoReply; //!< Receiver's timestamp
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/seq-ts-header.cc ns-3.47/src/applications/model/seq-ts-header.cc
--- ns-3.46/src/applications/model/seq-ts-header.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/seq-ts-header.cc	2026-02-16 16:08:49.571229700 -0800
@@ -21,8 +21,7 @@
 NS_OBJECT_ENSURE_REGISTERED(SeqTsHeader);
 
 SeqTsHeader::SeqTsHeader()
-    : m_seq(0),
-      m_ts(Simulator::Now().GetTimeStep())
+    : m_ts{Simulator::Now()}
 {
     NS_LOG_FUNCTION(this);
 }
@@ -45,7 +44,7 @@
 SeqTsHeader::GetTs() const
 {
     NS_LOG_FUNCTION(this);
-    return TimeStep(m_ts);
+    return m_ts;
 }
 
 TypeId
@@ -68,7 +67,7 @@
 SeqTsHeader::Print(std::ostream& os) const
 {
     NS_LOG_FUNCTION(this << &os);
-    os << "(seq=" << m_seq << " time=" << TimeStep(m_ts).As(Time::S) << ")";
+    os << "(seq=" << m_seq << " time=" << m_ts.As(Time::S) << ")";
 }
 
 uint32_t
@@ -84,7 +83,7 @@
     NS_LOG_FUNCTION(this << &start);
     Buffer::Iterator i = start;
     i.WriteHtonU32(m_seq);
-    i.WriteHtonU64(m_ts);
+    i.WriteHtonU64(m_ts.GetTimeStep());
 }
 
 uint32_t
@@ -93,7 +92,7 @@
     NS_LOG_FUNCTION(this << &start);
     Buffer::Iterator i = start;
     m_seq = i.ReadNtohU32();
-    m_ts = i.ReadNtohU64();
+    m_ts = TimeStep(i.ReadNtohU64());
     return GetSerializedSize();
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/seq-ts-header.h ns-3.47/src/applications/model/seq-ts-header.h
--- ns-3.46/src/applications/model/seq-ts-header.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/seq-ts-header.h	2026-02-16 16:08:49.571229700 -0800
@@ -61,8 +61,8 @@
     uint32_t Deserialize(Buffer::Iterator start) override;
 
   private:
-    uint32_t m_seq; //!< Sequence number
-    uint64_t m_ts;  //!< Timestamp
+    uint32_t m_seq{0}; //!< Sequence number
+    Time m_ts;         //!< Timestamp
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/sink-application.cc ns-3.47/src/applications/model/sink-application.cc
--- ns-3.46/src/applications/model/sink-application.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/sink-application.cc	2026-02-16 16:08:49.571229700 -0800
@@ -9,6 +9,7 @@
 #include "sink-application.h"
 
 #include "ns3/log.h"
+#include "ns3/socket.h"
 #include "ns3/uinteger.h"
 
 namespace ns3
@@ -37,7 +38,15 @@
                 "Port on which the application listens for incoming packets.",
                 UintegerValue(INVALID_PORT),
                 MakeUintegerAccessor(&SinkApplication::SetPort, &SinkApplication::GetPort),
-                MakeUintegerChecker<uint32_t>());
+                MakeUintegerChecker<uint32_t>())
+            .AddTraceSource("Rx",
+                            "A packet has been received",
+                            MakeTraceSourceAccessor(&SinkApplication::m_rxTrace),
+                            "ns3::Packet::AddressTracedCallback")
+            .AddTraceSource("RxWithoutAddress",
+                            "A packet has been received from a given address",
+                            MakeTraceSourceAccessor(&SinkApplication::m_rxTraceWithoutAddress),
+                            "ns3::Packet::TracedCallback");
     return tid;
 }
 
@@ -53,6 +62,15 @@
 }
 
 void
+SinkApplication::DoDispose()
+{
+    NS_LOG_FUNCTION(this);
+    m_socket = nullptr;
+    m_socket6 = nullptr;
+    Application::DoDispose();
+}
+
+void
 SinkApplication::SetLocal(const Address& addr)
 {
     NS_LOG_FUNCTION(this << addr);
@@ -82,4 +100,69 @@
     return m_port;
 }
 
+void
+SinkApplication::StartApplication()
+{
+    NS_LOG_FUNCTION(this);
+
+    // note: it is currently not possible to restart an application
+
+    m_socket = Socket::CreateSocket(GetNode(), m_protocolTid);
+    if (m_local.IsInvalid() && !m_socket6)
+    {
+        // local address is not specified, so create another socket to also listen to all IPv6
+        // addresses
+        m_socket6 = Socket::CreateSocket(GetNode(), m_protocolTid);
+    }
+
+    DoStartApplication();
+}
+
+void
+SinkApplication::StopApplication()
+{
+    NS_LOG_FUNCTION(this);
+    DoStopApplication();
+    CloseAllSockets();
+}
+
+bool
+SinkApplication::CloseAllSockets()
+{
+    NS_LOG_FUNCTION(this);
+    auto ret = CloseSocket(m_socket);
+    ret = CloseSocket(m_socket6) && ret;
+    return ret;
+}
+
+bool
+SinkApplication::CloseSocket(Ptr<Socket> socket)
+{
+    NS_LOG_FUNCTION(this << socket);
+    if (socket)
+    {
+        const auto ret = socket->Close();
+        socket->SetAcceptCallback(MakeNullCallback<bool, Ptr<Socket>, const Address&>(),
+                                  MakeNullCallback<void, Ptr<Socket>, const Address&>());
+        socket->SetCloseCallbacks(MakeNullCallback<void, Ptr<Socket>>(),
+                                  MakeNullCallback<void, Ptr<Socket>>());
+        socket->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
+        socket->SetSendCallback(MakeNullCallback<void, Ptr<Socket>, uint32_t>());
+        return (ret == 0);
+    }
+    return true;
+}
+
+void
+SinkApplication::DoStartApplication()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+void
+SinkApplication::DoStopApplication()
+{
+    NS_LOG_FUNCTION(this);
+}
+
 } // Namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/sink-application.h ns-3.47/src/applications/model/sink-application.h
--- ns-3.46/src/applications/model/sink-application.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/sink-application.h	2026-02-16 16:08:49.571229700 -0800
@@ -11,12 +11,17 @@
 
 #include "ns3/address.h"
 #include "ns3/application.h"
+#include "ns3/traced-callback.h"
 
 #include <limits>
 
 namespace ns3
 {
 
+class Packet;
+class Address;
+class Socket;
+
 /**
  * @ingroup applications
  * @brief Base class for sink applications.
@@ -55,10 +60,32 @@
     static constexpr uint32_t INVALID_PORT{std::numeric_limits<uint32_t>::max()}; //!< invalid port
 
   protected:
+    void DoDispose() override;
+
+    /**
+     * @brief Close all the sockets
+     * @return true if all sockets closed successfully, false otherwise
+     */
+    bool CloseAllSockets();
+
+    /// Callbacks for tracing the packet Rx events
+    ns3::TracedCallback<Ptr<const Packet>> m_rxTraceWithoutAddress;
+
+    /// Traced Callback: received packets, source address.
+    TracedCallback<Ptr<const Packet>, const Address&> m_rxTrace;
+
+    Ptr<Socket> m_socket;  //!< Socket (IPv4 or IPv6, depending on local address)
+    Ptr<Socket> m_socket6; //!< IPv6 Socket (used if only port is specified)
+
+    TypeId m_protocolTid; //!< Protocol TypeId value
+
     Address m_local; //!< Local address to bind to (address and port)
     uint32_t m_port; //!< Local port to bind to
 
   private:
+    void StartApplication() override;
+    void StopApplication() override;
+
     /**
      * @brief set the local address
      * @param addr local address
@@ -82,6 +109,23 @@
      * @return the server port
      */
     uint32_t GetPort() const;
+
+    /**
+     * @brief Close the socket
+     * @param socket the socket to close
+     * @return true if the socket closed successfully, false otherwise
+     */
+    bool CloseSocket(Ptr<Socket> socket);
+
+    /**
+     * @brief Application specific startup code for child subclasses
+     */
+    virtual void DoStartApplication();
+
+    /**
+     * @brief Application specific shutdown code for child subclasses
+     */
+    virtual void DoStopApplication();
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/source-application.cc ns-3.47/src/applications/model/source-application.cc
--- ns-3.46/src/applications/model/source-application.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/source-application.cc	2026-02-16 16:08:49.571229700 -0800
@@ -8,7 +8,11 @@
 
 #include "source-application.h"
 
+#include "ns3/inet-socket-address.h"
+#include "ns3/inet6-socket-address.h"
 #include "ns3/log.h"
+#include "ns3/packet-socket-address.h"
+#include "ns3/socket.h"
 #include "ns3/uinteger.h"
 
 namespace ns3
@@ -43,12 +47,24 @@
                           "All 8 bits of the TOS byte are set (including ECN bits).",
                           UintegerValue(0),
                           MakeUintegerAccessor(&SourceApplication::m_tos),
-                          MakeUintegerChecker<uint8_t>());
+                          MakeUintegerChecker<uint8_t>())
+            .AddTraceSource("Tx",
+                            "A packet is sent",
+                            MakeTraceSourceAccessor(&SourceApplication::m_txTrace),
+                            "ns3::Packet::TracedCallback")
+            .AddTraceSource("ConnectionSucceeded",
+                            "Succeeded to establish connection",
+                            MakeTraceSourceAccessor(&SourceApplication::m_connectionSuccess),
+                            "ns3::SourceApplication::ConnectionEventCallback")
+            .AddTraceSource("ConnectionFailed",
+                            "Failed to establish connection",
+                            MakeTraceSourceAccessor(&SourceApplication::m_connectionFailure),
+                            "ns3::SourceApplication::ConnectionEventCallback");
     return tid;
 }
 
-SourceApplication::SourceApplication()
-    : m_peer{}
+SourceApplication::SourceApplication(bool allowPacketSocket)
+    : m_allowPacketSocket{allowPacketSocket}
 {
     NS_LOG_FUNCTION(this);
 }
@@ -59,6 +75,15 @@
 }
 
 void
+SourceApplication::DoDispose()
+{
+    NS_LOG_FUNCTION(this);
+    CancelEvents();
+    m_socket = nullptr;
+    Application::DoDispose();
+}
+
+void
 SourceApplication::SetRemote(const Address& addr)
 {
     NS_LOG_FUNCTION(this << addr);
@@ -74,4 +99,128 @@
     return m_peer;
 }
 
+Ptr<Socket>
+SourceApplication::GetSocket() const
+{
+    return m_socket;
+}
+
+void
+SourceApplication::StartApplication()
+{
+    NS_LOG_FUNCTION(this);
+
+    // note: it is currently not possible to restart an application
+
+    NS_ABORT_MSG_IF(m_peer.IsInvalid(), "Remote address not properly set");
+    if (!m_local.IsInvalid())
+    {
+        NS_ABORT_MSG_IF((Inet6SocketAddress::IsMatchingType(m_peer) &&
+                         InetSocketAddress::IsMatchingType(m_local)) ||
+                            (InetSocketAddress::IsMatchingType(m_peer) &&
+                             Inet6SocketAddress::IsMatchingType(m_local)),
+                        "Incompatible peer and local address IP version");
+    }
+
+    m_socket = Socket::CreateSocket(GetNode(), m_protocolTid);
+    m_socket->SetConnectCallback(MakeCallback(&SourceApplication::ConnectionSucceeded, this),
+                                 MakeCallback(&SourceApplication::ConnectionFailed, this));
+
+    int ret{-1};
+    if (InetSocketAddress::IsMatchingType(m_peer) ||
+        (m_allowPacketSocket && PacketSocketAddress::IsMatchingType(m_peer)))
+    {
+        ret = m_socket->Bind();
+    }
+    else if (Inet6SocketAddress::IsMatchingType(m_peer))
+    {
+        ret = m_socket->Bind6();
+    }
+    else
+    {
+        NS_FATAL_ERROR("Incompatible address type: " << m_peer);
+    }
+    if (ret == -1)
+    {
+        NS_FATAL_ERROR("Failed to bind socket");
+    }
+
+    if (InetSocketAddress::IsMatchingType(m_peer))
+    {
+        m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
+    }
+
+    m_socket->Connect(m_peer);
+
+    CancelEvents();
+
+    DoStartApplication();
+}
+
+void
+SourceApplication::StopApplication()
+{
+    NS_LOG_FUNCTION(this);
+    DoStopApplication();
+    CancelEvents();
+    CloseSocket();
+}
+
+bool
+SourceApplication::CloseSocket()
+{
+    m_connected = false;
+    if (m_socket)
+    {
+        const auto ret = m_socket->Close();
+        m_socket->SetConnectCallback(MakeNullCallback<void, Ptr<Socket>>(),
+                                     MakeNullCallback<void, Ptr<Socket>>());
+        m_socket->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
+        return (ret == 0);
+    }
+    return true;
+}
+
+void
+SourceApplication::ConnectionSucceeded(Ptr<Socket> socket)
+{
+    NS_LOG_FUNCTION(this << socket);
+    m_connected = true;
+    DoConnectionSucceeded(socket);
+    m_connectionSuccess(socket, m_local, m_peer);
+}
+
+void
+SourceApplication::ConnectionFailed(Ptr<Socket> socket)
+{
+    NS_LOG_FUNCTION(this << socket);
+    m_connected = false;
+    DoConnectionFailed(socket);
+    m_connectionFailure(socket, m_local, m_peer);
+}
+
+void
+SourceApplication::DoStartApplication()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+void
+SourceApplication::DoStopApplication()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+void
+SourceApplication::DoConnectionSucceeded(Ptr<Socket> socket)
+{
+    NS_LOG_FUNCTION(this << socket);
+}
+
+void
+SourceApplication::DoConnectionFailed(Ptr<Socket> socket)
+{
+    NS_LOG_FUNCTION(this << socket);
+}
+
 } // Namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/applications/model/source-application.h ns-3.47/src/applications/model/source-application.h
--- ns-3.46/src/applications/model/source-application.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/applications/model/source-application.h	2026-02-16 16:08:49.571229700 -0800
@@ -11,10 +11,14 @@
 
 #include "ns3/address.h"
 #include "ns3/application.h"
+#include "ns3/traced-callback.h"
 
 namespace ns3
 {
 
+class Packet;
+class Socket;
+
 /**
  * @ingroup applications
  * @brief Base class for source applications.
@@ -40,7 +44,11 @@
      */
     static TypeId GetTypeId();
 
-    SourceApplication();
+    /**
+     * @brief Constructor
+     * @param allowPacketSocket flag whether the application should allow the use of packet sockets
+     */
+    explicit SourceApplication(bool allowPacketSocket = true);
     ~SourceApplication() override;
 
     /**
@@ -55,10 +63,95 @@
      */
     Address GetRemote() const;
 
+    /**
+     * @brief Get the socket this application is attached to.
+     * @return pointer to associated socket
+     */
+    Ptr<Socket> GetSocket() const;
+
   protected:
+    void DoDispose() override;
+
+    /**
+     * @brief Close the socket
+     * @return true if the socket was closed, false if there was no socket to close
+     */
+    bool CloseSocket();
+
+    /// Traced Callback: transmitted packets.
+    TracedCallback<Ptr<const Packet>> m_txTrace;
+
+    /**
+     * TracedCallback signature for connection success/failure event.
+     *
+     * @param [in] socket The socket for which connection succeeded/failed.
+     * @param [in] local The local address.
+     * @param [in] remote The remote address.
+     */
+    typedef void (*ConnectionEventCallback)(Ptr<Socket> socket,
+                                            const Address& local,
+                                            const Address& remote);
+
+    /// Traced Callback: connection success event.
+    TracedCallback<Ptr<Socket>, const Address&, const Address&> m_connectionSuccess;
+
+    /// Traced Callback: connection failure event.
+    TracedCallback<Ptr<Socket>, const Address&, const Address&> m_connectionFailure;
+
+    Ptr<Socket> m_socket; //!< Socket
+
+    TypeId m_protocolTid; //!< Protocol TypeId value
+
     Address m_peer;  //!< Peer address
     Address m_local; //!< Local address to bind to
     uint8_t m_tos;   //!< The packets Type of Service
+
+    bool m_connected{false}; //!< flag whether socket is connected
+
+  private:
+    void StartApplication() override;
+    void StopApplication() override;
+
+    /**
+     * @brief Handle a Connection Succeed event
+     * @param socket the connected socket
+     */
+    void ConnectionSucceeded(Ptr<Socket> socket);
+
+    /**
+     * @brief Handle a Connection Failed event
+     * @param socket the not connected socket
+     */
+    void ConnectionFailed(Ptr<Socket> socket);
+
+    /**
+     * @brief Application specific startup code for child subclasses
+     */
+    virtual void DoStartApplication();
+
+    /**
+     * @brief Application specific shutdown code for child subclasses
+     */
+    virtual void DoStopApplication();
+
+    /**
+     * @brief Application specific code for child subclasses upon a Connection Succeed event
+     * @param socket the connected socket
+     */
+    virtual void DoConnectionSucceeded(Ptr<Socket> socket);
+
+    /**
+     * @brief Application specific code for child subclasses upon a Connection Failed event
+     * @param socket the not connected socket
+     */
+    virtual void DoConnectionFailed(Ptr<Socket> socket);
+
+    /**
+     * @brief Cancel all pending events.
+     */
+    virtual void CancelEvents() = 0;
+
+    bool m_allowPacketSocket; //!< Allow use of packet socket
 };
 
 } // namespace ns3
